#include <stdio.h>
#include "util-ieee.h"
#include <fenv.h> /* gestion de l'environnement flottant */

int main () 
{
  cfloat a, b, sup, sdown;
  
  a.s.sig = 0; /* a = 2 - 2^(-23) = 1.1111...111 */
  a.s.exp = 0+127;
  a.s.man = (2<<22)-1; /* que des 1 */
  cfloat_print("             a",a);
  printf("\n");

  b.s.sig = 0; /* b = 2^(-24) */
  b.s.exp = -24+127;
  b.s.man = 0;
  cfloat_print("             b",b);  
  printf("\n");

  fesetround(FE_UPWARD); /* passe en arrondi vers le haut */
  sup.f = a.f + b.f;
  cfloat_print("  (a+b) rnd up",sup);  
  printf("\n");

  fesetround(FE_DOWNWARD); /* passe en arrondi vers le bas */
  sdown.f = a.f + b.f;
  cfloat_print("(a+b) rnd down",sdown); 
  printf("\n");
  
  return 0;
}
